using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.IO;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml.Serialization;

namespace shark.AmzWs
{
	/// <summary>
	/// Summary description for Books.
	/// </summary>
	public class Books : System.Web.UI.Page
	{
		private DataSet dataset;

		protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.DataGrid DataGrid3;
		protected System.Web.UI.WebControls.DataGrid DataGrid2;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			Label1.Visible = false;
			if ( ! IsPostBack )
			{
				LoadBooks("0735614229,1590590392,0735615829,1590590104");
			}
		}
		
		private void LoadBooks(string asinList )
		{
			// create the Web Service (proxy) object
			Amazon.AmazonSearchService ws = new
				Amazon.AmazonSearchService();

			// create the request object
			Amazon.AsinRequest request = new Amazon.AsinRequest();

			request.asin = asinList;
			request.type = "lite";
			request.devtag = "D1PX88SHH45VLE";

			Amazon.ProductInfo info;
			try
			{			
				info = ws.AsinSearchRequest( request );
			}
			catch( Exception ex )
			{
				ShowError(ex.Message);
				return;
			}

			// convert the info.Details array to XML and load DataSet
			XmlSerializer serializer =
				new XmlSerializer( info.Details.GetType() );
			StringWriter writer = new StringWriter();
			StreamWriter file = new StreamWriter("C:\\dets2.xml");
			
			serializer.Serialize(writer, info.Details );
			serializer.Serialize(file, info.Details );
			StringReader reader = new StringReader( writer.ToString() );
			
			dataset = new DataSet();
			dataset.ReadXml( reader );

			// bind the grids
			DataGrid1.DataSource = dataset.Tables[0];
			DataGrid1.DataBind();

			DataGrid2.DataSource = dataset.Tables[1];
			DataGrid2.DataBind();

			if ( dataset.Tables.Count > 2 )
			{
				DataGrid3.DataSource = dataset.Tables[2];
				DataGrid3.DataBind();
			}
		}
		
		private void ShowError( string msg )
		{
			Label1.Visible = true;
			Label1.Text = msg;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
