using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.IO;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml.Serialization;

namespace shark.AmzWs
{
	/// <summary>
	/// Summary description for Books.
	/// </summary>
	public class Books2 : System.Web.UI.Page
	{
		private DataSet dataset;

		protected System.Web.UI.WebControls.DataGrid bookGrid;
		protected System.Web.UI.WebControls.Label errorLabel;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			errorLabel.Visible = false;
			if ( ! IsPostBack )
			{
				LoadBooks("0735614229,1590590392,0735615829,1590590104");
			}
		}
		
		private void LoadBooks(string asinList )
		{
			// create the Web Service (proxy) object
			Amazon.AmazonSearchService ws = new
				Amazon.AmazonSearchService();

			// create the request object
			Amazon.AsinRequest request = new Amazon.AsinRequest();

			request.asin = asinList;
			request.type = "lite";
			request.devtag = "D1PX88SHH45VLE";

			Amazon.ProductInfo info;
			try
			{			
				info = ws.AsinSearchRequest( request );
			}
			catch( Exception ex )
			{
				ShowError(ex.Message);
				return;
			}

			// convert the info.Details array to XML and load DataSet
			XmlSerializer serializer =
				new XmlSerializer( info.Details.GetType() );
			StringWriter writer = new StringWriter();
			serializer.Serialize(writer, info.Details );
			StringReader reader = new StringReader( writer.ToString() );
			
			dataset = new DataSet();
			dataset.ReadXml( reader );

			// bind the two grids
			bookGrid.DataSource = dataset.Tables[0];
			bookGrid.DataBind();

		}

		public string GetAuthors( string id )
		{
			DataRow[] rows;
			if ( dataset.Tables.Count > 2 )
				rows = dataset.Tables[2].Select( "Authors_Id=" + id );
			else
				rows = dataset.Tables[1].Select( "Details_Id=" + id );
			
			string names = "";
			for( int i = 0; i < rows.Length; i++ )
			{
				if ( i > 0 )
					names += (i == rows.Length - 1 ) ? " and " : ", ";
				names += rows[i][0].ToString();
			}
			return names;				
		}
				
		private void ShowError( string msg )
		{
			errorLabel.Visible = true;
			errorLabel.Text = msg;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
